% Random Snake by Harrison Tsai
%
% Straight Sense: go to food if the snake's head is in food col or row

function heading = straight_sense(p, o)

global snake_i snake_j food_i food_j

if (snake_i > food_i && snake_j == food_j) % food directly to left of snake head
    if (strcmp(o, 'right'))
        go = 'right';
    else
        go = 'left';
    end
elseif (snake_i < food_i && snake_j == food_j) % food directly to right of snake head
    if (strcmp(o, 'left'))
        go = 'left';
    else
        go = 'right';
    end 
elseif (snake_j < food_j && snake_i == food_i) % food directly above snake head
    if (strcmp(o, 'down'))
        go = 'down';
    else
        go = 'up';
    end
elseif (snake_j > food_j && snake_i == food_i) % food directly below snake head
    if (strcmp(o, 'up'))
        go = 'up';
    else
        go = 'down';
    end
else % Pure Probability
    if (p < 2/3) % go straight relative to the snake's heading
        go = o;
    elseif (p < 5/6) % turn left relative to the snake's heading
        switch o
            case 'up'
                go = 'left';
            case 'down'
                go = 'right';
            case 'left'
                go = 'down';
            case 'right'
                go = 'up';
            otherwise
        end
    else
        switch o % turn right relative to the snake's heading
            case 'up'
                go = 'right';
            case 'down'
                go = 'left';
            case 'left'
                go = 'up';
            case 'right'
                go = 'down';
            otherwise
        end
    end
end
heading = go;